package rocks.zipcode.io.quiz3.arrays;

/**
 * @author leon on 09/12/2018.
 */
public class TicTacToe {

    private String[][] board;

    public TicTacToe(String[][] board) {
        this.board=board;
    }

    public String[] getRow(Integer value) {
        String[] result = new String[3];
        result[0]= board[value][0];
        result[1]= board[value][1];
        result[2]= board[value][2];
        return result;
    }

    public String[] getColumn(Integer value) {
        String[] result = new String[3];
        result[0]= board[0][value];
        result[1]= board[1][value];
        result[2]= board[2][value];
        return result;
    }

    public Boolean isRowHomogenous(Integer rowIndex) {
        String[] row = getRow(rowIndex);
        if(row[0].equals(row[1]) && row[1].equals(row[2]))
            return true;
        return false;
    }

    public Boolean isColumnHomogeneous(Integer columnIndex) {
        String[] column = getColumn(columnIndex);
        if(column[0].equals(column[1]) && column[1].equals(column[2]))
            return true;
        return false;
    }

    public Boolean isDiag1Homo(){
        if(board[0][0].equals(board[1][1]) && board[1][1].equals(board[2][2])) return true;
        return false;
    }

    public Boolean isDiag2Homo(){
        if(board[0][2].equals(board[1][1]) && board[1][1].equals(board[2][0])) return true;
        return false;
    }

    public String getWinner() {
        for (int i = 0; i < 3; i++) {
            if (isColumnHomogeneous(i))return board[0][i];
            if(isRowHomogenous(i)) return board[i][0];
            if (isDiag1Homo()) return board[0][0];
            if(isDiag2Homo()) return board[0][2];
        }
        return "No Winner";
    }
}
