package rocks.zipcode.io.quiz3.collections;

import rocks.zipcode.io.quiz3.objectorientation.enums.LabStatus;

import java.util.HashMap;
import java.util.Map;
import java.util.TreeMap;

/**
 * @author leon on 10/12/2018.
 */
public class Student {

    Map<Lab, LabStatus> map;

    public Student() {
        this(new HashMap<>());
    }

    public Student(Map<Lab, LabStatus> map) {
        this.map=map;
    }

    public void setLabStatus(Lab lab, LabStatus labStatus) {

        map.put(lab,labStatus);
        if(!lab.getForked()){
            throw new UnsupportedOperationException("Method not yet implemented"); }
    }


    public void forkLab(Lab lab) {
       lab.setForked(true);
       map.put(lab, LabStatus.PENDING);
    }

    public LabStatus getLabStatus(String labName) {
        //throw new UnsupportedOperationException("Method not yet implemented");
        for (Lab l: map.keySet()) {
            if( l.getName().equals(labName)) {
                return map.get(l);
            }
        }
       // throw new UnsupportedOperationException("Method not yet implemented");
        return null;
    }

    @Override
    public String toString(){
        String result = "";
        for (Lab l: map.keySet()) {
            if(result.equals("")){result=l.getName() + " > " + getLabStatus(l.getName()) + "\n";}
            else if (l.getName().charAt(0)<result.charAt(0))
            {result = l.getName() + " > " + getLabStatus(l.getName()) + "\n" + result;}
            else {result += l.getName() + " > " + getLabStatus(l.getName()) + "\n";}
        }
        return result.substring(0, result.length()-1);
    }
}
